
// SampleChartDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SampleChart.h"
#include "SampleChartDlg.h"
#include "afxdialogex.h"
#include "Aspect.h"
#include "BarSeries.h"
#include "LineSeries.h"
#include "Brush.h"
#include "Canvas.h"
#include "Marks.h"
#include "Pen.h"
#include "PointSeries.h"
#include "Pointer.h"
#include "Scroll.h"
#include "Series.h"
#include "TeeFunction.h"
#include "Zoom.h"
#include "tchart.h"
#include "axes.h"
#include "axis.h"
#include "axislabels.h"
#include "axistitle.h"
#include "titles.h"
#include "legend.h"
#include "export.h"
#include "toollist.h"
#include "tools.h"
#include "rotatetool.h"
#include "printer.h"
#include "bmpexport.h"
#include "pngexport.h"
#include "jpegexport.h"
#include "horizbarseries.h"
#include "panel.h"
#include "gradient.h"
#include "walls.h"
#include "wall.h"
#include "teefont.h"
#include "bezierseries.h"
#include "strings.h"
#include "areaseries.h"
#include "environment.h"
#include "chartaxispen.h"
#include "toollist.h"
#include "tools.h"
#include "markstiptool.h"
#include "ValueList.h"
#include <math.h>
#include <set>
#include "smithseries.h"
#include "polarseries.h"
#include "teegdiplus.h"
//#include "seriespointeritems.h"
#include "circlelabels.h"
#include "chartfont.h"
#include <fstream>
#include <algorithm>
#include <sstream>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CSampleChartDlg dialog



CSampleChartDlg::CSampleChartDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CSampleChartDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSampleChartDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TCHART1, mChart_);
}

BEGIN_MESSAGE_MAP(CSampleChartDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDOK, &CSampleChartDlg::OnBnClickedOk)
END_MESSAGE_MAP()


// CSampleChartDlg message handlers

BOOL CSampleChartDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	PlotLine();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSampleChartDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSampleChartDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSampleChartDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CSampleChartDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	CDialogEx::OnOK();
}

void CSampleChartDlg::PlotLine()
{
	std::set<double> setY;
	std::set<double> setX;

	//ReadData("dummyData11.txt", setX, setY);	//mix e-10, e-11
	//ReadData("dummyData12.txt", setX, setY);	//all e-12
	//ReadData("dummyData13.txt", setX, setY);	//all e-13
	//ReadData("dummyData14.txt", setX, setY);	//all e-14
	ReadData("dummyData1314.txt", setX, setY);	//mix e-13,e-14

	CTChart* pchart_ = &mChart_;
	pchart_->GetAspect().SetView3D(false);
	pchart_->GetLegend().SetVisible(FALSE);
	pchart_->SetClipPoints(true);
	pchart_->GetAxis().SetDrawAxesBeforeSeries(true);
	pchart_->SetTimerInterval(0);
	pchart_->GetAspect().SetHorizOffset(1);
	pchart_->GetAspect().SetVertOffset(1);
	pchart_->GetScroll().SetEnable(false);
	pchart_->GetLegend().SetVisible(FALSE);
	pchart_->GetWalls().SetVisible(true);
	pchart_->GetAxis().GetBottom().SetVisible(true);
	pchart_->GetAxis().GetLeft().SetVisible(true);

	pchart_->GetAxis().GetRight().SetVisible(false);
	pchart_->GetAxis().GetTop().SetVisible(false);
	pchart_->GetAxis().GetBottom().SetAutomatic(true);
	pchart_->GetAxis().GetLeft().SetAutomatic(true);

	pchart_->GetEnvironment().SetMouseWheelScroll(FALSE);
	pchart_->StopMouse();
	pchart_->GetZoom().SetEnable(FALSE);
	pchart_->GetZoom().SetMouseButton(FALSE);

	long LINE_TYPE = 0;
	int plot_id = pchart_->AddSeries(LINE_TYPE);

	pchart_->Series(plot_id).SetVerticalAxis(0);

	if (setX.size() != setY.size())
		return;

	std::set<double>::const_iterator x_iter = setX.begin();
	std::set<double>::const_iterator y_iter = setY.begin();

	for (; x_iter != setX.end() && y_iter != setY.end();
		++x_iter, ++y_iter)
	{
		pchart_->Series(plot_id).AddXY(*x_iter, *y_iter, "", RGB(0,255,0));
	}

	CustomizeLabelDisplay(pchart_, 10, setY);
}

void CSampleChartDlg::CheckDecimalPoint(const double dVal, int &count)
{
	double val = abs(dVal);

	while (val > 0 && val < 1)
	{
		val = val * 10;
		count++;
	}
}

void CSampleChartDlg::CustomizeLabelDisplay(CTChart *pchart_,
													 const int interval,
													 const std::set<double> &set_values)
{
	std::set<double> set_labels;
	if (!set_values.empty())
	{
		double min = 0;
		double max = 0;
		std::set<double>::iterator itr = set_values.begin();
		min = *itr;

		std::set<double>::reverse_iterator ritr = set_values.rbegin();
		max = *ritr;

		double increment = (max - min) / interval;

		set_labels.insert(min);
		for (int i = 1; i <= interval - 1; i++)
		{
			min = min + increment;
			set_labels.insert(min);
		}
		set_labels.insert(max);
	}

	for (std::set<double>::iterator itr = set_labels.begin();
		itr != set_labels.end();
		++itr)
	{
		std::ostringstream oss;
		CString str("");

		int count = 1;
		CheckDecimalPoint(*itr, count);
		if (count < 6)
		{
			std::ostringstream ossFormat;
			ossFormat << "%.";
			ossFormat << count;
			ossFormat << "f";

			str.Format(ossFormat.str().c_str(), *itr);

			oss << str;
		}
		else
		{
			std::ostringstream ossFormat;
			ossFormat << *itr;

			CString strVal(ossFormat.str().c_str());
			int pos1 = strVal.Find("e");
			if (pos1 != -1)
			{
				CString str1 = strVal.Mid(0, pos1);
				CString str2 = strVal.Mid(pos1);

				int pos2 = str1.Find(".");
				if (pos2 != -1)
				{
					double dVal = atof(str1);
					str.Format("%.2f", dVal);
				}
				else
					str = str1;

				str.TrimRight('0');
				str += str2;

				oss << str;
			}
			else
				oss << *itr;
		}

		pchart_->GetAxis().GetLeft().GetLabels().Add(*itr, oss.str().c_str());
	}
}

void CSampleChartDlg::ReadData(std::string fileName, 
										std::set<double>& setX,
										std::set<double>& setY)
{
	std::string strLine;
	std::ifstream file(fileName);
	setX.clear();
	setY.clear();

	while (std::getline(file, strLine)) 
	{
		int iLength = strLine.length();
		if (iLength> 0) 
		{
			int iPos = strLine.find(',');
			if (iPos <= 0)
				continue;

			std::string strX;
			std::string strY;

			int iLen = strLine.length();

			strX = strLine.substr(0, iPos);
			strY = strLine.substr(iPos + 1);

			std::stringstream ssX;
			ssX << strX;

			std::stringstream ssY;
			ssY << strY;

			double dValueX{ 0.0 };
			ssX >> dValueX;

			double dValueY{ 0.0 };
			ssY >> dValueY;

			setX.insert(dValueX);
			setY.insert(dValueY);
		}
	}
}